#ifndef APDUMANAGER_H
#define APDUMANAGER_H

#include "SecureFWGlobals.h"
#include "..\Shared\cardcomm.h"

class CAPDUManager {
    //
    // ATTRIBUTES
    //
private:
    HANDLE      m_hSession;                 // ACTUAL OPENED SESSION HANDLE

    //
    // METHODS
    //
public:
    CAPDUManager();
    ~CAPDUManager();
    
    // OPEN SESSION TO GIVEN SLOT AND CARD IDENTIFICATION
    // SLOT ID CAN BE 'SLOT_ANY_AVAILABLE'(-1) FOR INTERACTIVE CHOOSE FROM ALL AVAILABLE CARDS
    // CARD IDENTIFICATION CAN SET TO MORE THAN ONE CARD TYPE, SEPARATED BY ZERO (\0)
    //      FOR EXAMPLE 'JavaCard\0MPCOS\0OPENCARD\0GXPPro-R3\0  
    int OpenSession(int slotID, char* acceptedCards);
    
    // CLOSE ACTUAL OPENED SESSION
    // IF NO SESSION IS OPENED, SUCCESS IS ALSO RETURNED
    int CloseSession();
    
    // EXCHANGE APDU WITH CARD AND RECEIVE RESPONSE
    int ExchangeAPDU(CARDAPDU* pAPDU);    

protected:
    // TRANSLATE RETURN CODE FROM SPECIFIC FUNCTION TO RETURN CODES DEFINED IN 'status.h"
    static int TranslateCardCommError(int CardCommError);
    static int TranslateISO7816Error(int iso7816Error);
};

#endif