#ifndef SECUREFWGLOBALS_H
#define SECUREFWGLOBALS_H

#include "SecureFWConstants.h"
#include <memory.h>

#ifndef BYTE
    typedef unsigned char  BYTE;
#endif
#ifndef USHORT
    typedef unsigned short USHORT;
#endif
#ifndef BOOL
    typedef int  BOOL; 
#endif

// STANDARD CONSTANTS
#undef FALSE
#undef TRUE
#undef NULL

#define FALSE   0
#define TRUE    1
#define NULL    0


#define HIGHBYTE(x)  x >> 8 
#define LOWBYTE(x)   x & 0xFF 

typedef struct _SHORT_DATA_BLOB {
    BYTE*   pData;
    USHORT  dataLen;

    _SHORT_DATA_BLOB() {
        pData = NULL;
        clear();
    }

    void clear() {
        if (pData) delete[] pData;
        dataLen = 0;
    }
} SHORT_DATA_BLOB, MASTER_LICENCE, ALG_LICENCE;

typedef struct _REMOTE_ALG {
    BOOL    valid;
    BYTE    algorithmUUID[ALGORITHM_UUID_LENGTH_MAX];
    BYTE    algorithmUUIDLen;

    _REMOTE_ALG() {
        clear();
    }

    void clear() {
        valid = FALSE;

        memset(algorithmUUID, 0, ALGORITHM_UUID_LENGTH_MAX);
        algorithmUUIDLen = 0;
    }
} REMOTE_ALG;

typedef struct _SWA_PROFILE {
    BOOL    valid;

    BYTE    swaUUID[SWA_UUID_LENGTH];    
    BYTE    swaUUIDLen;

    _SWA_PROFILE() {
        clear();
    }

    void clear() {
        valid = FALSE;

        memset(swaUUID, 0, SWA_UUID_LENGTH);
        swaUUIDLen = 0;
    }
} SWA_PROFILE;

typedef struct _REMOTE_APPLET {
    BOOL    valid;
    int     slotID;
    char    acceptedCards[ACCEPTED_CARDS_LENGTH_MAX];
    
    BYTE    hwtUUID[HWT_UUID_LENGTH];    
    BYTE    hwtUUIDLen;

    BYTE    appletAID[AID_LEN_MAX];
    BYTE    appletAIDLen;

    
    _REMOTE_APPLET() {
        clear();
    }

    void clear() {
        valid = FALSE; 
        slotID = SLOT_ANY_AVAILABLE;
        memset(acceptedCards, 0, ACCEPTED_CARDS_LENGTH_MAX);

        memset(hwtUUID, 0, HWT_UUID_LENGTH);
        hwtUUIDLen = 0;

        memset(appletAID, 0, AID_LEN_MAX);
        appletAIDLen = 0;
    }
} REMOTE_APPLET;


#endif
